diff --git a/res/res_pjsip/pjsip_options.c b/res/res_pjsip/pjsip_options.c
index d4ea911c95..9bec5de7b1 100644
--- a/res/res_pjsip/pjsip_options.c
+++ b/res/res_pjsip/pjsip_options.c
@@ -66,839 +294,1544 @@ const char *ast_sip_get_contact_short_status_label(const enum ast_sip_contact_st
 	return short_status_map[status];
 }
 
-/*!
- * \internal
- * \brief Destroy a ast_sip_contact_status object.
- */
-static void contact_status_destroy(void * obj)
+/*! \brief Hashing function for contact statuses */
+static int sip_contact_status_hash(const void *obj, const int flags)
+{
+	const struct ast_sip_contact_status *object;
+	const char *key;
+
+	switch (flags & OBJ_SEARCH_MASK) {
+	case OBJ_SEARCH_KEY:
+		key = obj;
+		break;
+	case OBJ_SEARCH_OBJECT:
+		object = obj;
+		key = object->name;
+		break;
+	default:
+		ast_assert(0);
+		return 0;
+	}
+	return ast_str_hash(key);
+}
+
+/*! \brief Comparator function for contact statuses */
+static int sip_contact_status_cmp(void *obj, void *arg, int flags)
+{
+	const struct ast_sip_contact_status *object_left = obj;
+	const struct ast_sip_contact_status *object_right = arg;
+	const char *right_key = arg;
+	int cmp;
+
+	switch (flags & OBJ_SEARCH_MASK) {
+	case OBJ_SEARCH_OBJECT:
+		right_key = object_right->name;
+		/* Fall through */
+	case OBJ_SEARCH_KEY:
+		cmp = strcmp(object_left->name, right_key);
+		break;
+	case OBJ_SEARCH_PARTIAL_KEY:
+		cmp = strncmp(object_left->name, right_key, strlen(right_key));
+		break;
+	default:
+		cmp = 0;
+		break;
+	}
+	if (cmp) {
+		return 0;
+	}
+	return CMP_MATCH;
+}
+
+/*! \brief Destructor for contact statuses */
+static void sip_contact_status_destroy(void *obj)
+{
+	struct ast_sip_contact_status *contact_status = obj;
+
+	ast_free(contact_status->aor);
+	ast_free(contact_status->uri);
+}
+
+struct ast_sip_contact_status *ast_res_pjsip_find_or_create_contact_status(const struct ast_sip_contact *contact)
+{
+	struct ast_sip_contact_status *contact_status;
+	size_t size = sizeof(*contact_status) + strlen(ast_sorcery_object_get_id(contact)) + 1;
+
+	/* At startup it is possible for contact status to be retrieved before we are ready, if this occurs then
+	 * allocate the container here. Since we don't actually trigger qualify or anything as a result it is safe
+	 * to do so. They'll just get back a contact status that will be updated later.
+	 */
+	if (!sip_options_contact_statuses) {
+		sip_options_contact_statuses = ao2_container_alloc_hash(AO2_ALLOC_OPT_LOCK_MUTEX, 0, CONTACT_BUCKETS,
+			sip_contact_status_hash, NULL, sip_contact_status_cmp);
+		if (!sip_options_contact_statuses) {
+			return NULL;
+		}
+	}
+
+	ao2_lock(sip_options_contact_statuses);
+
+	/* If contact status for this contact already exists just return it */
+	contact_status = ao2_find(sip_options_contact_statuses, ast_sorcery_object_get_id(contact), OBJ_SEARCH_KEY | OBJ_NOLOCK);
+	if (contact_status) {
+		ao2_unlock(sip_options_contact_statuses);
+		return contact_status;
+	}
+
+	/* Otherwise we have to create and store a new contact status */
+	contact_status = ao2_alloc(size, sip_contact_status_destroy);
+	if (!contact_status) {
+		ao2_unlock(sip_options_contact_statuses);
+		return NULL;
+	}
+
+	/* This will get later updated by the result of the OPTIONS request
+	 * or it will forever stay in CREATED.
+	 */
+	contact_status->status = CREATED;
+	contact_status->aor = ast_strdup(contact->aor);
+	contact_status->uri = ast_strdup(contact->uri);
+	if (!contact_status->aor || !contact_status->uri) {
+		ao2_unlock(sip_options_contact_statuses);
+		ao2_ref(contact_status, -1);
+		return NULL;
+	}
+
+	contact_status->rtt = 0;
+	strcpy(contact_status->name, ast_sorcery_object_get_id(contact)); /* SAFE */
+
+	ao2_link_flags(sip_options_contact_statuses, contact_status, OBJ_NOLOCK);
+	ao2_unlock(sip_options_contact_statuses);
+
+	ast_statsd_log_string_va("PJSIP.contacts.states.%s", AST_STATSD_GAUGE,
+		"+1", 1.0, ast_sip_get_contact_status_label(contact_status->status));
+
+	return contact_status;
+}
+
+struct ast_sip_contact_status *ast_sip_get_contact_status(const struct ast_sip_contact *contact)
+{
+	return ao2_find(sip_options_contact_statuses, ast_sorcery_object_get_id(contact), OBJ_SEARCH_KEY);
+}
+
+/*! \brief Hashing function for OPTIONS AORs */
+static int sip_options_aor_hash(const void *obj, const int flags)
+{
+	const struct sip_options_aor *object;
+	const char *key;
+
+	switch (flags & OBJ_SEARCH_MASK) {
+	case OBJ_SEARCH_KEY:
+		key = obj;
+		break;
+	case OBJ_SEARCH_OBJECT:
+		object = obj;
+		key = object->name;
+		break;
+	default:
+		ast_assert(0);
+		return 0;
+	}
+	return ast_str_hash(key);
+}
+
+/*! \brief Comparator function for SIP OPTIONS AORs */
+static int sip_options_aor_cmp(void *obj, void *arg, int flags)
+{
+	const struct sip_options_aor *object_left = obj;
+	const struct sip_options_aor *object_right = arg;
+	const char *right_key = arg;
+	int cmp;
+
+	switch (flags & OBJ_SEARCH_MASK) {
+	case OBJ_SEARCH_OBJECT:
+		right_key = object_right->name;
+		/* Fall through */
+	case OBJ_SEARCH_KEY:
+		cmp = strcmp(object_left->name, right_key);
+		break;
+	case OBJ_SEARCH_PARTIAL_KEY:
+		cmp = strncmp(object_left->name, right_key, strlen(right_key));
+		break;
+	default:
+		cmp = 0;
+		break;
+	}
+	if (cmp) {
+		return 0;
+	}
+	return CMP_MATCH;
+}
+
+/*! \brief Forward declaration of this helpful function */
+static int sip_options_remove_contact(void *obj, void *arg, int flags);
+
+/*! \brief Destructor function for SIP OPTIONS AORs */
+static void sip_options_aor_destroy(void *obj)
+{
+	struct sip_options_aor *aor_options = obj;
+
+	/* Any contacts are unreachable since the AOR is being destroyed so remove their contact status */
+	ao2_callback(aor_options->permanent_contacts, OBJ_NODATA | OBJ_UNLINK, sip_options_remove_contact, aor_options);
+	ao2_callback(aor_options->dynamic_contacts, OBJ_NODATA | OBJ_UNLINK, sip_options_remove_contact, aor_options);
+
+	ast_taskprocessor_unreference(aor_options->serializer);
+	AST_VECTOR_FREE(&aor_options->compositors);
+	ao2_cleanup(aor_options->permanent_contacts);
+	ao2_cleanup(aor_options->dynamic_contacts);
+}
+
+/*! \brief Hashing function for contacts */
+static int sip_contact_hash(const void *obj, const int flags)
+{
+	const struct ast_sip_contact *object;
+	const char *key;
+
+	switch (flags & OBJ_SEARCH_MASK) {
+	case OBJ_SEARCH_KEY:
+		key = obj;
+		break;
+	case OBJ_SEARCH_OBJECT:
+		object = obj;
+		key = ast_sorcery_object_get_id(object);
+		break;
+	default:
+		ast_assert(0);
+		return 0;
+	}
+	return ast_str_hash(key);
+}
+
+/*! \brief Comparator function for contacts */
+static int sip_contact_cmp(void *obj, void *arg, int flags)
+{
+	const struct ast_sip_contact *object_left = obj;
+	const struct ast_sip_contact *object_right = arg;
+	const char *right_key = arg;
+	int cmp;
+
+	switch (flags & OBJ_SEARCH_MASK) {
+	case OBJ_SEARCH_OBJECT:
+		right_key = ast_sorcery_object_get_id(object_right);
+		/* Fall through */
+	case OBJ_SEARCH_KEY:
+		cmp = strcmp(ast_sorcery_object_get_id(object_left), right_key);
+		break;
+	case OBJ_SEARCH_PARTIAL_KEY:
+		cmp = strncmp(ast_sorcery_object_get_id(object_left), right_key, strlen(right_key));
+		break;
+	default:
+		cmp = 0;
+		break;
+	}
+	if (cmp) {
+		return 0;
+	}
+	return CMP_MATCH;
+}
+
+/*! \brief Hashing function for endpoint state compositors */
+static int sip_endpoint_state_compositor_hash(const void *obj, const int flags)
+{
+	const struct sip_options_endpoint_state_compositor *object;
+	const char *key;
+
+	switch (flags & OBJ_SEARCH_MASK) {
+	case OBJ_SEARCH_KEY:
+		key = obj;
+		break;
+	case OBJ_SEARCH_OBJECT:
+		object = obj;
+		key = object->name;
+		break;
+	default:
+		ast_assert(0);
+		return 0;
+	}
+	return ast_str_hash(key);
+}
+
+/*! \brief Comparator function for endpoint state compositors */
+static int sip_endpoint_state_compositor_cmp(void *obj, void *arg, int flags)
 {
-	struct ast_sip_contact_status *status = obj;
+	const struct sip_options_endpoint_state_compositor *object_left = obj;
+	const struct sip_options_endpoint_state_compositor *object_right = arg;
+	const char *right_key = arg;
+	int cmp;
+
+	switch (flags & OBJ_SEARCH_MASK) {
+	case OBJ_SEARCH_OBJECT:
+		right_key = object_right->name;
+		/* Fall through */
+	case OBJ_SEARCH_KEY:
+		cmp = strcmp(object_left->name, right_key);
+		break;
+	case OBJ_SEARCH_PARTIAL_KEY:
+		cmp = strncmp(object_left->name, right_key, strlen(right_key));
+		break;
+	default:
+		cmp = 0;
+		break;
+	}
+	if (cmp) {
+		return 0;
+	}
+	return CMP_MATCH;
+}
+
+/*! \brief Structure used to contain information for an OPTIONS callback */
+struct sip_options_contact_callback_data {
+	/*! \brief The contact we qualified */
+	struct ast_sip_contact *contact;
+	/*! \brief The AOR options */
+	struct sip_options_aor *aor_options;
+	/*! \brief The contact status this relates to */
+	struct ast_sip_contact_status *contact_status;
+	/*! \brief The time at which this OPTIONS attempt was started */
+	struct timeval rtt_start;
+	/*! \brief The new status of the contact */
+	enum ast_sip_contact_status_type status;
+};
+
+/*! \brief Function which notifies endpoint state compositors of a state change of an AOR */
+static void sip_options_notify_endpoint_state_compositors(struct sip_options_aor *aor_options,
+	enum ast_sip_contact_status_type status)
+{
+	int i;
+
+	/* Iterate through the associated endpoint state compositors updating them */
+	for (i = 0; i < AST_VECTOR_SIZE(&aor_options->compositors); ++i) {
+		struct sip_options_endpoint_state_compositor *endpoint_state_compositor =
+			AST_VECTOR_GET(&aor_options->compositors, i);
+
+		ao2_lock(endpoint_state_compositor);
+
+		/* During synchronization we can still have a reference to an endpoint state compositor but
+		 * it may be in a state where all state updates to it are suspended. We know this because it
+		 * will have no AORs feeding it.
+		 */
+		if (ao2_container_count(endpoint_state_compositor->aors)) {
+			if (status == AVAILABLE) {
+				endpoint_state_compositor->available++;
+
+				/* If we were previously unavailable change the underlying endpoint state */
+				if (endpoint_state_compositor->available == 1) {
+					ast_debug(3, "Endpoint state compositor '%s' has become available, updating endpoint state\n",
+						endpoint_state_compositor->name);
+					ast_sip_persistent_endpoint_update_state(endpoint_state_compositor->name, AST_ENDPOINT_ONLINE);
+				}
+			} else if (status == UNAVAILABLE) {
+				endpoint_state_compositor->available--;
+
+				/* If we were previously available change the underlying endpoint state */
+				if (!endpoint_state_compositor->available) {
+					ast_debug(3, "Endpoint state compositor '%s' has become unavailable, updating endpoint state\n",
+						endpoint_state_compositor->name);
+					ast_sip_persistent_endpoint_update_state(endpoint_state_compositor->name, AST_ENDPOINT_OFFLINE);
+				}
+			}
+
+			ast_debug(3, "Endpoint state compositor '%s' now has %d available AORs\n", endpoint_state_compositor->name,
+				endpoint_state_compositor->available);
+		}
+
+		ao2_unlock(endpoint_state_compositor);
+	}
+}
+
+/*! \brief Function which publishes a contact status update to all interested endpoints */
+static void sip_options_publish_contact_state(struct sip_options_aor *aor_options,
+	const struct ast_sip_contact_status *contact_status)
+{
+	int i;
+
+	for (i = 0; i < AST_VECTOR_SIZE(&aor_options->compositors); ++i) {
+		struct sip_options_endpoint_state_compositor *endpoint_state_compositor =
+			AST_VECTOR_GET(&aor_options->compositors, i);
+
+			ast_sip_persistent_endpoint_publish_contact_state(endpoint_state_compositor->name, contact_status);
+	}
+}
+
+/*! \brief Task to notify an AOR of a contact status change */
+static int sip_options_contact_status_notify_task(void *obj)
+{
+	struct sip_options_contact_callback_data *contact_callback_data = obj;
+	struct ast_sip_contact *contact;
+
+	/* Determine if this is a late arriving notification, as it is possible that we get
+	 * a callback from PJSIP giving us contact status but in the mean time said contact
+	 * has been removed from the underlying AOR.
+	 */
+	if (!contact_callback_data->aor_options->qualify_frequency) {
+		return 0;
+	}
+
+	contact = ao2_find(contact_callback_data->aor_options->permanent_contacts, contact_callback_data->contact, OBJ_SEARCH_OBJECT);
+	if (!contact) {
+		contact = ao2_find(contact_callback_data->aor_options->dynamic_contacts, contact_callback_data->contact, OBJ_SEARCH_OBJECT);
+		if (!contact) {
+			return 0;
+		}
+	}
+	ao2_ref(contact, -1);
+
+	/* Update the contact specific status information */
+	contact_callback_data->contact_status->last_status = contact_callback_data->contact_status->status;
+	contact_callback_data->contact_status->status = contact_callback_data->status;
+	contact_callback_data->contact_status->rtt = contact_callback_data->contact_status->status == AVAILABLE
+		&& contact_callback_data->rtt_start.tv_sec > 0
+		? ast_tvdiff_us(ast_tvnow(), contact_callback_data->rtt_start)
+		: 0;
+
+	/* If the status has changed then notify the endpoint state compositors and publish our events. */
+	if (contact_callback_data->contact_status->last_status != contact_callback_data->contact_status->status) {
+		if (contact_callback_data->contact_status->status == AVAILABLE) {
+			/* If this is the first available contact then the AOR has become available */
+			contact_callback_data->aor_options->available++;
+			if (contact_callback_data->aor_options->available == 1) {
+				sip_options_notify_endpoint_state_compositors(contact_callback_data->aor_options, AVAILABLE);
+			}
+		} else if (contact_callback_data->contact_status->last_status == AVAILABLE &&
+			contact_callback_data->contact_status->status == UNAVAILABLE) {
+			/* If there are no more available contacts then this AOR is unavailable */
+			contact_callback_data->aor_options->available--;
+			if (!contact_callback_data->aor_options->available) {
+				sip_options_notify_endpoint_state_compositors(contact_callback_data->aor_options, UNAVAILABLE);
+			}
+		}
+
+		sip_options_publish_contact_state(contact_callback_data->aor_options, contact_callback_data->contact_status);
+
+		ast_verb(3, "Contact %s/%s is now %s.  RTT: %.3f msec\n",
+			contact_callback_data->contact_status->aor,contact_callback_data->contact_status->uri,
+			ast_sip_get_contact_status_label(contact_callback_data->contact_status->status),
+			contact_callback_data->contact_status->rtt / 1000.0);
+
+		ast_statsd_log_string_va("PJSIP.contacts.states.%s", AST_STATSD_GAUGE,
+			"-1", 1.0, ast_sip_get_contact_status_label(contact_callback_data->contact_status->last_status));
+		ast_statsd_log_string_va("PJSIP.contacts.states.%s", AST_STATSD_GAUGE,
+			"+1", 1.0, ast_sip_get_contact_status_label(contact_callback_data->contact_status->status));
+
+		ast_test_suite_event_notify("AOR_CONTACT_UPDATE",
+			"Contact: %s\r\n"
+			"Status: %s",
+			contact_callback_data->contact_status->name,
+			ast_sip_get_contact_status_label(contact_callback_data->contact_status->status));
+	} else {
+		ast_debug(3, "Contact %s/%s status didn't change: %s, RTT: %.3f msec\n",
+			contact_callback_data->contact_status->aor, contact_callback_data->contact_status->uri,
+			ast_sip_get_contact_status_label(contact_callback_data->contact_status->status),
+			contact_callback_data->contact_status->rtt / 1000.0);
+	}
+
+	ast_statsd_log_full_va("PJSIP.contacts.%s.rtt", AST_STATSD_TIMER,
+		contact_callback_data->contact_status->status != AVAILABLE ? -1 : contact_callback_data->contact_status->rtt / 1000,
+		1.0,
+		contact_callback_data->contact_status->name);
+
+	ast_test_suite_event_notify("AOR_CONTACT_QUALIFY_RESULT",
+		"Contact: %s\r\n"
+		"Status: %s\r\n"
+		"RTT: %" PRId64,
+		contact_callback_data->contact_status->name,
+		ast_sip_get_contact_status_label(contact_callback_data->contact_status->status),
+		contact_callback_data->contact_status->rtt);
+
+	ast_debug(3, "AOR '%s' now has %d available contacts\n", contact_callback_data->aor_options->name,
+		contact_callback_data->aor_options->available);
+
+	ao2_ref(contact_callback_data, -1);
+
+	return 0;
+}
+
+/*! \brief Callback for when we get a result from a SIP OPTIONS request (a response or a timeout) */
+static void qualify_contact_cb(void *token, pjsip_event *e)
+{
+	struct sip_options_contact_callback_data *contact_callback_data = token;
+	enum ast_sip_contact_status_type status;
+
+	switch(e->body.tsx_state.type) {
+	default:
+		ast_log(LOG_ERROR, "Unexpected PJSIP event %u\n", e->body.tsx_state.type);
+		/* Fall through */
+	case PJSIP_EVENT_TRANSPORT_ERROR:
+	case PJSIP_EVENT_TIMER:
+		status = UNAVAILABLE;
+		break;
+	case PJSIP_EVENT_RX_MSG:
+		status = AVAILABLE;
+		break;
+	}
+
+	/* Update the callback data with the new status, this will get handled in the AOR serializer */
+	contact_callback_data->status = status;
+
+	if (ast_sip_push_task(contact_callback_data->aor_options->serializer, sip_options_contact_status_notify_task,
+		contact_callback_data)) {
+		ast_log(LOG_NOTICE, "Unable to queue contact status update for '%s' on AOR '%s', state will be incorrect\n",
+			contact_callback_data->contact_status->name, contact_callback_data->aor_options->name);
+		ao2_ref(contact_callback_data, -1);
+	}
+
+	/* The task inherited our reference so we don't unreference here */
+}
+
+/*! \brief Destructor for contact callback data */
+static void sip_options_contact_callback_data_destroy(void *obj)
+{
+	struct sip_options_contact_callback_data *contact_callback_data = obj;
+
+	ao2_cleanup(contact_callback_data->contact);
+	ao2_cleanup(contact_callback_data->aor_options);
+	ao2_cleanup(contact_callback_data->contact_status);
+}
+
+/*! \brief Contact callback data allocator */
+static struct sip_options_contact_callback_data *sip_options_contact_callback_data_alloc(
+	struct ast_sip_contact *contact, struct sip_options_aor *aor_options,
+	struct ast_sip_contact_status *contact_status)
+{
+	struct sip_options_contact_callback_data *contact_callback_data;
+
+	contact_callback_data = ao2_alloc_options(sizeof(*contact_callback_data), sip_options_contact_callback_data_destroy,
+		AO2_ALLOC_OPT_LOCK_NOLOCK);
+	if (!contact_callback_data) {
+		return NULL;
+	}
+
+	contact_callback_data->contact = ao2_bump(contact);
+	contact_callback_data->aor_options = ao2_bump(aor_options);
+	contact_callback_data->contact_status = ao2_bump(contact_status);
+	contact_callback_data->rtt_start = ast_tvnow();
+
+	return contact_callback_data;
+}
+
+/*! \brief Send a SIP OPTIONS request for a contact */
+static int sip_options_qualify_contact(void *obj, void *arg, int flags)
+{
+	struct ast_sip_contact *contact = obj;
+	struct sip_options_aor *aor_options = arg;
+	struct ast_sip_endpoint *endpoint = NULL;
+	pjsip_tx_data *tdata;
+	struct ast_sip_contact_status *contact_status;
+	struct sip_options_contact_callback_data *contact_callback_data;
+
+	ast_debug(3, "Qualifying contact '%s' on AOR '%s'\n", ast_sorcery_object_get_id(contact), aor_options->name);
 
-	ast_free(status->aor);
-	ast_free(status->uri);
-}
+	if (!ast_strlen_zero(contact->endpoint_name)) {
+		endpoint = ast_sorcery_retrieve_by_id(ast_sip_get_sorcery(), "endpoint", contact->endpoint_name);
+	}
+	if (!endpoint && AST_VECTOR_SIZE(&aor_options->compositors)) {
+		struct sip_options_endpoint_state_compositor *endpoint_state_compositor =
+			AST_VECTOR_GET(&aor_options->compositors, 0);
 
-/*!
- * \internal
- * \brief Create a ast_sip_contact_status object.
- */
-static void *contact_status_alloc(const char *name)
-{
-	struct ast_sip_contact_status *status = ast_sorcery_generic_alloc(sizeof(*status), contact_status_destroy);
-	char *id = ast_strdupa(name);
-	char *aor = id;
-	char *aor_separator = NULL;
+		endpoint = ast_sorcery_retrieve_by_id(ast_sip_get_sorcery(), "endpoint", endpoint_state_compositor->name);
+	}
+	if (!endpoint) {
+		return 0;
+	}
 
-	if (!status) {
-		ast_log(LOG_ERROR, "Unable to allocate ast_sip_contact_status\n");
-		return NULL;
+	if (ast_sip_create_request("OPTIONS", NULL, endpoint, NULL, contact, &tdata)) {
+		ast_log(LOG_ERROR, "Unable to create request to qualify contact %s on AOR %s\n",
+			contact->uri, aor_options->name);
+		ao2_ref(endpoint, -1);
+		return 0;
 	}
 
-	/* Dynamic contacts are delimited with ";@" and static ones with "@@" */
-	if ((aor_separator = strstr(id, ";@")) || (aor_separator = strstr(id, "@@"))) {
-		*aor_separator = '\0';
+	/* If an outbound proxy is specified set it on this request */
+	if (!ast_strlen_zero(contact->outbound_proxy) &&
+		ast_sip_set_outbound_proxy(tdata, contact->outbound_proxy)) {
+		pjsip_tx_data_dec_ref(tdata);
+		ast_log(LOG_ERROR, "Unable to apply outbound proxy on request to qualify contact %s\n",
+			contact->uri);
+		return 0;
 	}
-	ast_assert(aor_separator != NULL);
 
-	status->aor = ast_strdup(aor);
-	if (!status->aor) {
-		ao2_cleanup(status);
-		return NULL;
+	contact_status = ast_res_pjsip_find_or_create_contact_status(contact);
+	if (!contact_status) {
+		ast_log(LOG_ERROR, "Unable to retrieve contact status information for contact %s on AOR %s\n",
+			contact->uri, aor_options->name);
+		pjsip_tx_data_dec_ref(tdata);
+		ao2_ref(endpoint, -1);
+		return 0;
 	}
 
-	return status;
-}
+	contact_callback_data = sip_options_contact_callback_data_alloc(contact, aor_options, contact_status);
+	if (!contact_callback_data) {
+		ast_log(LOG_ERROR, "Unable to create object to contain callback data for contact %s on AOR %s\n",
+			contact->uri, aor_options->name);
+		pjsip_tx_data_dec_ref(tdata);
+		ao2_ref(endpoint, -1);
+		ao2_ref(contact_status, -1);
+		return 0;
+	}
 
-static int qualify_and_schedule_aor_contact(void *obj)
-{
-	struct ast_sip_contact *contact = obj;
-	struct ast_sip_aor *aor;
+	ao2_ref(contact_status, -1);
 
-	if (!contact || ast_strlen_zero(contact->aor) ||
-		!(aor = ast_sip_location_retrieve_aor(contact->aor))) {
-		ao2_ref(contact, -1);
-		return -1;
+	if (ast_sip_send_out_of_dialog_request(tdata, endpoint, (int)(aor_options->qualify_timeout * 1000), contact_callback_data, qualify_contact_cb) != PJ_SUCCESS) {
+		ast_log(LOG_ERROR, "Unable to send request to qualify contact %s on AOR %s\n",
+			contact->uri, aor_options->name);
+		ao2_ref(contact_callback_data, -1);
+		ao2_ref(endpoint, -1);
+		return 0;
 	}
 
-	contact->qualify_frequency = aor->qualify_frequency;
-	contact->qualify_timeout = aor->qualify_timeout;
-	contact->authenticate_qualify = aor->authenticate_qualify;
+	return 0;
+}
 
-	ao2_ref(aor, -1);
+/*! \brief Task to qualify contacts of an AOR */
+static int sip_options_qualify_aor_task(void *obj)
+{
+	struct sip_options_aor *aor_options = obj;
 
-	qualify_and_schedule(contact);
-	ao2_ref(contact, -1);
+	ast_debug(3, "Qualifying all contacts on AOR '%s'\n", aor_options->name);
+
+	/* Attempt to send an OPTIONS request to every contact on this AOR */
+	ao2_callback(aor_options->permanent_contacts, OBJ_NODATA, sip_options_qualify_contact, (struct sip_options_aor *)aor_options);
+	ao2_callback(aor_options->dynamic_contacts, OBJ_NODATA, sip_options_qualify_contact, (struct sip_options_aor *)aor_options);
+
+	ao2_ref(aor_options, -1);
 
 	return 0;
 }
 
-AST_MUTEX_DEFINE_STATIC(creation_lock);
-
-/*!
- * \brief Retrieve a ast_sip_contact_status object from sorcery creating
- *        one if not found.
- */
-struct ast_sip_contact_status *ast_res_pjsip_find_or_create_contact_status(const struct ast_sip_contact *contact)
+/*! \brief Scheduler callback for qualifying contacts of an AOR */
+static int sip_options_qualify_aor(const void *obj)
 {
-	struct ast_sip_contact_status *status;
-	SCOPED_MUTEX(lock, &creation_lock);
+	struct sip_options_aor *aor_options = (struct sip_options_aor *)obj;
 
-	status = ast_sorcery_retrieve_by_id(ast_sip_get_sorcery(), CONTACT_STATUS,
-		ast_sorcery_object_get_id(contact));
-	if (status) {
-		return status;
+	if (ast_sip_push_task(aor_options->serializer, sip_options_qualify_aor_task, ao2_bump(aor_options))) {
+		ao2_ref(aor_options, -1);
 	}
 
-	status = ast_sorcery_alloc(ast_sip_get_sorcery(), CONTACT_STATUS,
-		ast_sorcery_object_get_id(contact));
-	if (!status) {
-		ast_log(LOG_ERROR, "Unable to create ast_sip_contact_status for contact %s/%s\n",
-			contact->aor, contact->uri);
+	/* Always reschedule to the frequency we should go */
+	return aor_options->qualify_frequency * 1000;
+}
+
+/*! \brief Allocator for AOR OPTIONS */
+static struct sip_options_aor *sip_options_aor_alloc(struct ast_sip_aor *aor)
+{
+	struct sip_options_aor *aor_options;
+	char tps_name[AST_TASKPROCESSOR_MAX_NAME + 1];
+
+	aor_options = ao2_alloc_options(sizeof(*aor_options) + strlen(ast_sorcery_object_get_id(aor)) + 1, sip_options_aor_destroy,
+		AO2_ALLOC_OPT_LOCK_NOLOCK);
+	if (!aor_options) {
 		return NULL;
 	}
 
-	status->uri = ast_strdup(contact->uri);
-	if (!status->uri) {
-		ao2_cleanup(status);
+	ast_taskprocessor_build_name(tps_name, sizeof(tps_name), "pjsip/options/%s", ast_sorcery_object_get_id(aor));
+	aor_options->serializer = ast_sip_create_serializer_named(tps_name);
+	if (!aor_options->serializer) {
+		ao2_ref(aor_options, -1);
 		return NULL;
 	}
 
-	status->rtt_start = ast_tv(0, 0);
-	status->rtt = 0;
+	if (AST_VECTOR_INIT(&aor_options->compositors, ENDPOINT_STATE_COMPOSITOR_INITIAL_SIZE)) {
+		ao2_ref(aor_options, -1);
+		return NULL;
+	}
 
-	if (ast_sorcery_create(ast_sip_get_sorcery(), status)) {
-		ast_log(LOG_ERROR, "Unable to persist ast_sip_contact_status for contact %s\n",
-			contact->uri);
-		ao2_ref(status, -1);
+	aor_options->permanent_contacts = ao2_container_alloc_hash(AO2_ALLOC_OPT_LOCK_NOLOCK, 0, CONTACT_BUCKETS,
+		sip_contact_hash, NULL, sip_contact_cmp);
+	if (!aor_options->permanent_contacts) {
+		ao2_ref(aor_options, -1);
 		return NULL;
 	}
 
-	/* The permanent contact added after asterisk start should be qualified. */
-	if (ast_test_flag(&ast_options, AST_OPT_FLAG_FULLY_BOOTED) && ast_tvzero(contact->expiration_time)) {
-		/*
-		 * The FULLY_BOOTED to filter out contacts that already existed when asterisk started.
-		 * The zero expiration_time to select only permanent contacts.
-		 */
-		ao2_ref((struct ast_sip_contact *) contact, +1);
-		if (ast_sip_push_task(NULL, qualify_and_schedule_aor_contact, (struct ast_sip_contact *) contact)) {
-			ao2_ref((struct ast_sip_contact *) contact, -1);
-		}
+	aor_options->dynamic_contacts = ao2_container_alloc_hash(AO2_ALLOC_OPT_LOCK_NOLOCK, 0, CONTACT_BUCKETS,
+		sip_contact_hash, NULL, sip_contact_cmp);
+	if (!aor_options->dynamic_contacts) {
+		ao2_ref(aor_options, -1);
+		return NULL;
 	}
 
-	ast_statsd_log_string_va("PJSIP.contacts.states.%s", AST_STATSD_GAUGE,
-		"+1", 1.0, ast_sip_get_contact_status_label(status->status));
+	aor_options->sched_id = -1;
+	strcpy(aor_options->name, ast_sorcery_object_get_id(aor)); /* SAFE */
 
-	return status;
+	return aor_options;
 }
 
-/*!
- * \internal
- * \brief Update an ast_sip_contact_status's elements.
- */
-static void update_contact_status(const struct ast_sip_contact *contact,
-	enum ast_sip_contact_status_type value, int is_contact_refresh)
+/*! \brief Remove contact status for a hint */
+static void sip_options_remove_contact_status(struct sip_options_aor *aor_options,
+	struct ast_sip_contact *contact)
 {
-	RAII_VAR(struct ast_sip_contact_status *, status, NULL, ao2_cleanup);
-	RAII_VAR(struct ast_sip_contact_status *, update, NULL, ao2_cleanup);
+	struct ast_sip_contact_status *contact_status;
 
-	status = ast_res_pjsip_find_or_create_contact_status(contact);
-	if (!status) {
-		ast_log(LOG_ERROR, "Unable to find ast_sip_contact_status for contact %s\n",
-			contact->uri);
+	contact_status = ao2_find(sip_options_contact_statuses, ast_sorcery_object_get_id(contact), OBJ_SEARCH_KEY | OBJ_UNLINK);
+	if (!contact_status) {
+		ast_debug(3, "Attempted to remove contact status for '%s' but it does not exist\n",
+			ast_sorcery_object_get_id(contact));
 		return;
 	}
 
-	if (is_contact_refresh
-		&& status->status == CREATED) {
-		/*
-		 * The contact status hasn't been updated since creation
-		 * and we don't want to re-send a created status.
-		 */
-		if (contact->qualify_frequency
-			|| status->rtt_start.tv_sec > 0) {
-			/* Ignore, the status will change soon. */
-			return;
-		}
+	ast_verb(2, "Contact %s/%s has been deleted\n", contact->aor, contact->uri);
 
-		/*
-		 * Convert to a regular contact status update
-		 * because the status may never change.
-		 */
-		is_contact_refresh = 0;
-		value = UNKNOWN;
-	}
+	/* Update the contact status to reflect its new state */
+	contact_status->last_status = contact_status->status;
+	contact_status->status = REMOVED;
 
-	update = ast_sorcery_alloc(ast_sip_get_sorcery(), CONTACT_STATUS,
-		ast_sorcery_object_get_id(status));
-	if (!update) {
-		ast_log(LOG_ERROR, "Unable to allocate ast_sip_contact_status for contact %s\n",
-			contact->uri);
+	ast_statsd_log_string_va("PJSIP.contacts.states.%s", AST_STATSD_GAUGE,
+		"-1", 1.0, ast_sip_get_contact_status_label(contact_status->last_status));
+	ast_statsd_log_string_va("PJSIP.contacts.states.%s", AST_STATSD_GAUGE,
+		"+1", 1.0, ast_sip_get_contact_status_label(contact_status->status));
+
+	sip_options_publish_contact_state(aor_options, contact_status);
+
+	/* The only time we need to update the AOR is if this contact was available and qualify
+	 * is in use, otherwise we can just stop early.
+	 */
+	if (!aor_options->qualify_frequency || (contact_status->last_status != AVAILABLE)) {
+		ao2_ref(contact_status, -1);
 		return;
 	}
 
-	update->uri = ast_strdup(contact->uri);
-	if (!update->uri) {
-		return;
+	aor_options->available--;
+	if (!aor_options->available) {
+		sip_options_notify_endpoint_state_compositors(aor_options, UNAVAILABLE);
 	}
 
-	if (is_contact_refresh) {
-		/* Copy everything just to set the refresh flag. */
-		update->status = status->status;
-		update->last_status = status->last_status;
-		update->rtt = status->rtt;
-		update->rtt_start = status->rtt_start;
-		update->refresh = 1;
-	} else {
-		update->last_status = status->status;
-		update->status = value;
+	ast_debug(3, "AOR '%s' now has %d available contacts\n", aor_options->name,
+		aor_options->available);
 
-		/*
-		 * if the contact is available calculate the rtt as
-		 * the diff between the last start time and "now"
-		 */
-		update->rtt = update->status == AVAILABLE && status->rtt_start.tv_sec > 0
-			? ast_tvdiff_us(ast_tvnow(), status->rtt_start)
-			: 0;
-		update->rtt_start = ast_tv(0, 0);
+	ao2_ref(contact_status, -1);
+}
 
-		ast_test_suite_event_notify("AOR_CONTACT_QUALIFY_RESULT",
-			"Contact: %s\r\n"
-			"Status: %s\r\n"
-			"RTT: %" PRId64,
-			ast_sorcery_object_get_id(update),
-			ast_sip_get_contact_status_label(update->status),
-			update->rtt);
-	}
+/*! \brief Task data for AOR creation or updating */
+struct sip_options_synchronize_aor_task_data {
+	/*! \brief The AOR options for this AOR */
+	struct sip_options_aor *aor_options;
+	/*! \brief The AOR which contains the new configuraton */
+	struct ast_sip_aor *aor;
+	/*! \brief Optional container of existing AOR s*/
+	struct ao2_container *existing;
+	/*! \brief Whether this AOR is being added */
+	int added;
+};
 
-	if (ast_sorcery_update(ast_sip_get_sorcery(), update)) {
-		ast_log(LOG_ERROR, "Unable to update ast_sip_contact_status for contact %s\n",
-			contact->uri);
-	}
+/*! \brief Callback function to remove a contact and its contact status from an AOR */
+static int sip_options_remove_contact(void *obj, void *arg, int flags)
+{
+	struct ast_sip_contact *contact = obj;
+	struct sip_options_aor *aor_options = arg;
+
+	sip_options_remove_contact_status(aor_options, contact);
+
+	return CMP_MATCH;
 }
 
-/*!
- * \internal
- * \brief Initialize the start time on a contact status so the round
- *        trip time can be calculated upon a valid response.
- */
-static void init_start_time(const struct ast_sip_contact *contact)
+/*! \brief Determine an initial time for scheduling AOR qualifying */
+static int sip_options_determine_initial_qualify_time(int qualify_frequency)
 {
-	RAII_VAR(struct ast_sip_contact_status *, status, NULL, ao2_cleanup);
-	RAII_VAR(struct ast_sip_contact_status *, update, NULL, ao2_cleanup);
+	int initial_interval;
+	int max_time = ast_sip_get_max_initial_qualify_time();
 
-	status = ast_res_pjsip_find_or_create_contact_status(contact);
-	if (!status) {
-		ast_log(LOG_ERROR, "Unable to find ast_sip_contact_status for contact %s\n",
-			contact->uri);
-		return;
+	if (max_time && max_time < qualify_frequency) {
+		initial_interval = max_time;
+	} else {
+		initial_interval = qualify_frequency;
 	}
 
-	update = ast_sorcery_alloc(ast_sip_get_sorcery(), CONTACT_STATUS,
-		ast_sorcery_object_get_id(status));
-	if (!update) {
-		ast_log(LOG_ERROR, "Unable to copy ast_sip_contact_status for contact %s\n",
-			contact->uri);
-		return;
-	}
+	return (int)((initial_interval * 1000) * ast_random_double());
+}
 
-	update->uri = ast_strdup(contact->uri);
-	if (!update->uri) {
-		return;
+/*! \brief Function which applies configuration to an AOR options structure */
+static int sip_options_apply_aor_configuration(struct sip_options_aor *aor_options, struct ast_sip_aor *aor,
+	int new)
+{
+	struct ao2_container *existing_permanent_contacts;
+
+	ast_debug(3, "Configuring AOR '%s' with current state of configuration and world\n",
+		aor_options->name);
+
+	/* Permanent contacts, since we receive no notification that they are gone, follow the same
+	 * approach as AORs. We create a copy of the existing container and any reused contacts are
+	 * removed from it. Any contacts remaining in the container are no longer configured and we
+	 * need to remove their state.
+	 */
+	existing_permanent_contacts = ao2_container_clone(aor_options->permanent_contacts, 0);
+	if (!existing_permanent_contacts) {
+		ast_log(LOG_WARNING, "Synchronization of AOR '%s' failed for qualify, retaining existing state\n",
+			aor_options->name);
+		return -1;
 	}
 
-	update->status = status->status;
-	update->last_status = status->last_status;
-	update->rtt = status->rtt;
-	update->rtt_start = ast_tvnow();
+	ao2_callback(aor_options->permanent_contacts, OBJ_NODATA | OBJ_UNLINK | OBJ_MULTIPLE, NULL, NULL);
 
-	if (ast_sorcery_update(ast_sip_get_sorcery(), update)) {
-		ast_log(LOG_ERROR, "Unable to update ast_sip_contact_status for contact %s\n",
-			contact->uri);
+	if (aor->permanent_contacts) {
+		struct ao2_iterator it_contacts;
+		struct ast_sip_contact *contact;
+
+		it_contacts = ao2_iterator_init(aor->permanent_contacts, 0);
+		for (; (contact = ao2_iterator_next(&it_contacts)); ao2_ref(contact, -1)) {
+			ao2_link(aor_options->permanent_contacts, contact);
+			ao2_find(existing_permanent_contacts, ast_sorcery_object_get_id(contact), OBJ_NODATA | OBJ_UNLINK);
+		}
+		ao2_iterator_destroy(&it_contacts);
 	}
-}
 
-/*!
- * \internal
- * \brief For an endpoint try to match the given contact->aor.
- */
-static int on_endpoint(void *obj, void *arg, int flags)
-{
-	struct ast_sip_endpoint *endpoint = obj;
-	char *contact_aor = arg;
-	char *aor_name;
-	char *aors;
+	/* Any contact left is no longer configured, so raise events and make it disappear */
+	ao2_callback(existing_permanent_contacts, OBJ_NODATA | OBJ_UNLINK, sip_options_remove_contact, aor_options);
+	ao2_ref(existing_permanent_contacts, -1);
 
-	if (!arg || ast_strlen_zero(endpoint->aors)) {
-		return 0;
+	/* If this is newly added we need to see if there are any existing dynamic contacts
+	 * to add. Ones that are added after creation will occur as a result of the contact
+	 * observer creation callback.
+	 */
+	if (new) {
+		size_t prefix_len = strlen(ast_sorcery_object_get_id(aor)) + sizeof(";@") - 1;
+		char prefix[prefix_len + 1];
+		struct ao2_container *contacts;
+
+		sprintf(prefix, "%s;@", ast_sorcery_object_get_id(aor)); /* Safe */
+		contacts = ast_sorcery_retrieve_by_prefix(ast_sip_get_sorcery(), "contact", prefix, prefix_len);
+
+		if (contacts) {
+			ao2_container_dup(aor_options->dynamic_contacts, contacts, 0);
+			ao2_ref(contacts, -1);
+		}
 	}
 
-	aors = ast_strdupa(endpoint->aors);
-	while ((aor_name = ast_strip(strsep(&aors, ",")))) {
-		if (!strcmp(contact_aor, aor_name)) {
-			return CMP_MATCH;
+	/* Update the available count if we transition between qualified and unqualified. In the qualified case
+	 * we need to start with 0 available as the qualify process will take care of it. In the unqualified
+	 * case it is based on the number of contacts present.
+	 */
+	 if (!aor->qualify_frequency) {
+		aor_options->available = ao2_container_count(aor_options->dynamic_contacts) +
+			ao2_container_count(aor_options->permanent_contacts);
+		ast_debug(3, "AOR '%s' is unqualified, number of available contacts is therefore '%d'\n",
+			aor_options->name, aor_options->available);
+	 } else if (!aor_options->qualify_frequency && aor->qualify_frequency) {
+		aor_options->available = 0;
+		ast_debug(3, "AOR '%s' has transitioned from unqualified to qualified, reset available contacts to 0\n",
+			aor_options->name);
+	 }
+
+	/* If we need to stop or start the scheduled callback then do so. This occurs due to the following:
+	 * 1. The qualify frequency has changed
+	 * 2. Contacts were added when previously there were none
+	 * 3. There are no contacts but previously there were some
+	 */
+	if ((aor_options->qualify_frequency != aor->qualify_frequency) ||
+		(aor_options->sched_id == -1 && (ao2_container_count(aor_options->permanent_contacts) ||
+			ao2_container_count(aor_options->dynamic_contacts))) ||
+		(aor_options->sched_id != -1 && (ao2_container_count(aor_options->permanent_contacts) &&
+			ao2_container_count(aor_options->dynamic_contacts)))) {
+		AST_SCHED_DEL_UNREF(sched, aor_options->sched_id, ao2_t_ref(aor_options, -1, "Delete scheduler entry ref"));
+
+		/* If there is still a qualify frequency then schedule this */
+		if (aor->qualify_frequency && (ao2_container_count(aor_options->permanent_contacts) ||
+			ao2_container_count(aor_options->dynamic_contacts))) {
+			aor_options->sched_id = ast_sched_add_variable(sched, sip_options_determine_initial_qualify_time(aor->qualify_frequency),
+				sip_options_qualify_aor, ao2_bump(aor_options), 1);
+			if (aor_options->sched_id < 0) {
+				ao2_t_ref(aor_options, -1, "Cleanup failed scheduler add");
+				ast_log(LOG_ERROR, "Unable to schedule qualify for contacts of AOR '%s'\n", aor_options->name);
+			}
 		}
 	}
 
+	/* Update the AOR information with the state */
+	aor_options->qualify_frequency = aor->qualify_frequency;
+	aor_options->qualify_timeout = aor->qualify_timeout;
+	aor_options->authenticate_qualify = aor->authenticate_qualify;
+
+	ast_debug(3, "AOR '%s' now has %d available contacts\n", aor_options->name,
+		aor_options->available);
+
 	return 0;
 }
 
-/*!
- * \internal
- * \brief Find an endpoint associated with the given contact.
- */
-static struct ast_sip_endpoint *find_an_endpoint(struct ast_sip_contact *contact)
+/*! \brief Task to synchronize an AOR with our local state */
+static int sip_options_synchronize_aor_task(void *obj)
 {
-	struct ao2_container *endpoints;
-	struct ast_sip_endpoint *endpoint;
-	struct ast_variable *var;
-	char *aor = ast_alloca(strlen(contact->aor) + 3);
+	struct sip_options_synchronize_aor_task_data *task_data = obj;
+	int i;
 
-	sprintf(aor, "%%%s%%", contact->aor);
-	var = ast_variable_new("aors LIKE", aor, "");
-	endpoints = ast_sorcery_retrieve_by_fields(ast_sip_get_sorcery(),
-		"endpoint", AST_RETRIEVE_FLAG_MULTIPLE, var);
+	ast_debug(3, "Synchronizing AOR '%s' with current state of configuration and world\n",
+		task_data->aor_options->name);
 
-	ast_variables_destroy(var);
+	sip_options_apply_aor_configuration(task_data->aor_options, task_data->aor, task_data->added);
 
-	/*
-	 * Because aors are a string list, we have to use a pattern match but since a simple
-	 * pattern match could return an endpoint that has an aor of "aaabccc" when searching
-	 * for "abc", we still have to iterate over them to find an exact aor match.
+	/* Endpoint state compositors are removed in this operation but not added. To reduce the amount of
+	 * work done they are done later. In the mean time things can still qualify and once an endpoint
+	 * state compositor is added to the AOR it will be updated with the current state.
 	 */
-	endpoint = ao2_callback(endpoints, 0, on_endpoint, contact->aor);
-	ao2_ref(endpoints, -1);
+	for (i = 0; i < AST_VECTOR_SIZE(&task_data->aor_options->compositors); ++i) {
+		struct sip_options_endpoint_state_compositor *endpoint_state_compositor =
+		AST_VECTOR_GET(&task_data->aor_options->compositors, i);
+
+		ao2_lock(endpoint_state_compositor);
+
+		/* This purposely does not notify the endpoint state compositor to prevent flapping from
+		 * available, to unavailable, to available. Instead we just change it to a fresh state which
+		 * prevents all other AORs from updating it as well. When endpoint state compositor mappings
+		 * are re-established it will be updated to reflect the correct state. This will cause a notify
+		 * to go to the endpoint state compositor but the upper level endpoint state implementation
+		 * will ignore it unless the state has actually changed.
+		 */
+		ao2_callback(endpoint_state_compositor->aors, OBJ_NODATA | OBJ_MULTIPLE | OBJ_UNLINK, NULL, NULL);
+		endpoint_state_compositor->available = 0;
 
-	return endpoint;
+		ao2_unlock(endpoint_state_compositor);
+		ao2_ref(endpoint_state_compositor, -1);
+	}
+	AST_VECTOR_RESET(&task_data->aor_options->compositors, AST_VECTOR_ELEM_CLEANUP_NOOP);
+
+	return 0;
 }
 
-/*!
- * \internal
- * \brief Receive a response to the qualify contact request.
- */
-static void qualify_contact_cb(void *token, pjsip_event *e)
+/*! \brief Synchronize an AOR with our local state */
+static int sip_options_synchronize_aor(void *obj, void *arg, int flags)
 {
-	struct ast_sip_contact *contact = token;
+	struct sip_options_synchronize_aor_task_data task_data = { .aor = obj, .existing = arg, };
 
-	switch(e->body.tsx_state.type) {
-	default:
-		ast_log(LOG_ERROR, "Unexpected PJSIP event %u\n", e->body.tsx_state.type);
-		/* Fall through */
-	case PJSIP_EVENT_TRANSPORT_ERROR:
-	case PJSIP_EVENT_TIMER:
-		update_contact_status(contact, UNAVAILABLE, 0);
-		break;
-	case PJSIP_EVENT_RX_MSG:
-		update_contact_status(contact, AVAILABLE, 0);
-		break;
+	task_data.aor_options = ao2_find(sip_options_aors, ast_sorcery_object_get_id(task_data.aor), OBJ_SEARCH_KEY);
+	if (!task_data.aor_options) {
+		task_data.aor_options = sip_options_aor_alloc(task_data.aor);
+		if (!task_data.aor_options) {
+			return 0;
+		}
+
+		task_data.added = 1;
+	}
+
+	if (task_data.added) {
+		/* Nothing is aware of this AOR yet so we can just update it in this thread */
+		sip_options_synchronize_aor_task(&task_data);
+		ao2_link(sip_options_aors, task_data.aor_options);
+	} else {
+		/* This AOR already exists so we have to do manipulation in its serializer */
+		ast_sip_push_task_synchronous(task_data.aor_options->serializer, sip_options_synchronize_aor_task, &task_data);
+	}
+
+	ao2_ref(task_data.aor_options, -1);
+
+	if (task_data.existing) {
+		ao2_find(task_data.existing, (char *)ast_sorcery_object_get_id(task_data.aor), OBJ_SEARCH_KEY | OBJ_UNLINK | OBJ_NODATA);
 	}
-	ao2_cleanup(contact);
+
+	return 0;
 }
 
-/*!
- * \internal
- * \brief Attempt to qualify the contact
- *
- * \details Sends a SIP OPTIONS request to the given contact in order to make
- *         sure that contact is available.
- */
-static int qualify_contact(struct ast_sip_endpoint *endpoint, struct ast_sip_contact *contact)
+/*! \brief Destructor for endpoint state compositors */
+static void sip_options_endpoint_state_compositor_destroy(void *obj)
 {
-	pjsip_tx_data *tdata;
-	RAII_VAR(struct ast_sip_endpoint *, endpoint_local, NULL, ao2_cleanup);
+	struct sip_options_endpoint_state_compositor *endpoint_state_compositor = obj;
 
-	if (endpoint) {
-		endpoint_local = ao2_bump(endpoint);
-	} else {
-		if (!ast_strlen_zero(contact->endpoint_name)) {
-			endpoint_local = ast_sorcery_retrieve_by_id(ast_sip_get_sorcery(), "endpoint", contact->endpoint_name);
-		}
-		if (!endpoint_local) {
-			endpoint_local = find_an_endpoint(contact);
-		}
-		if (!endpoint_local) {
-			ast_log(LOG_WARNING, "Unable to find an endpoint to qualify contact %s. Deleting this contact\n",
-				contact->uri);
-			contact_deleted(contact);
-			return -1;
-		}
+	ao2_cleanup(endpoint_state_compositor->aors);
+}
+
+/*! \brief Find (or create) an endpoint state compositor */
+static struct sip_options_endpoint_state_compositor *sip_options_endpoint_state_compositor_find_or_alloc(const struct ast_sip_endpoint *endpoint)
+{
+	struct sip_options_endpoint_state_compositor *endpoint_state_compositor;
+
+	ao2_lock(sip_options_endpoint_state_compositors);
+	endpoint_state_compositor = ao2_find(sip_options_endpoint_state_compositors, ast_sorcery_object_get_id(endpoint), OBJ_SEARCH_KEY | OBJ_NOLOCK);
+	if (endpoint_state_compositor) {
+		ao2_unlock(sip_options_endpoint_state_compositors);
+		return endpoint_state_compositor;
 	}
 
-	if (ast_sip_create_request("OPTIONS", NULL, endpoint_local, NULL, contact, &tdata)) {
-		ast_log(LOG_ERROR, "Unable to create request to qualify contact %s\n",
-			contact->uri);
-		return -1;
+	endpoint_state_compositor = ao2_alloc(sizeof(*endpoint_state_compositor) + strlen(ast_sorcery_object_get_id(endpoint)) + 1,
+		sip_options_endpoint_state_compositor_destroy);
+	if (!endpoint_state_compositor) {
+		ao2_unlock(sip_options_endpoint_state_compositors);
+		return NULL;
 	}
 
-	/* If an outbound proxy is specified set it on this request */
-	if (!ast_strlen_zero(contact->outbound_proxy) &&
-		ast_sip_set_outbound_proxy(tdata, contact->outbound_proxy)) {
-		pjsip_tx_data_dec_ref(tdata);
-		ast_log(LOG_ERROR, "Unable to apply outbound proxy on request to qualify contact %s\n",
-			contact->uri);
-		return -1;
+	endpoint_state_compositor->aors = ast_str_container_alloc_options(AO2_ALLOC_OPT_LOCK_NOLOCK, 1);
+	if (!endpoint_state_compositor->aors) {
+		ao2_unlock(sip_options_endpoint_state_compositors);
+		ao2_ref(endpoint_state_compositor, -1);
+		return NULL;
 	}
 
-	init_start_time(contact);
+	strcpy(endpoint_state_compositor->name, ast_sorcery_object_get_id(endpoint)); /* SAFE */
 
-	ao2_ref(contact, +1);
-	if (ast_sip_send_out_of_dialog_request(tdata, endpoint_local, (int)(contact->qualify_timeout * 1000), contact, qualify_contact_cb)
-		!= PJ_SUCCESS) {
-		ast_log(LOG_ERROR, "Unable to send request to qualify contact %s\n",
-			contact->uri);
-		update_contact_status(contact, UNAVAILABLE, 0);
-		ao2_ref(contact, -1);
-		return -1;
+	ao2_link_flags(sip_options_endpoint_state_compositors, endpoint_state_compositor, OBJ_NOLOCK);
+	ao2_unlock(sip_options_endpoint_state_compositors);
+
+	return endpoint_state_compositor;
+}
+
+/*! \brief Task details for adding an AOR to an endpoint state compositor */
+struct sip_options_endpoint_compositor_task_data {
+	/*! \brief The AOR options that the endpoint state compositor should be added to */
+	struct sip_options_aor *aor_options;
+	/*! \brief The endpoint state compositor */
+	struct sip_options_endpoint_state_compositor *endpoint_state_compositor;
+};
+
+/*! \brief Task which adds an AOR to an endpoint state compositor */
+static int sip_options_endpoint_compositor_add_task(void *obj)
+{
+	struct sip_options_endpoint_compositor_task_data *task_data = obj;
+
+	ast_debug(3, "Adding endpoint compositor '%s' to AOR '%s'\n", task_data->endpoint_state_compositor->name,
+		task_data->aor_options->name);
+
+	AST_VECTOR_APPEND(&task_data->aor_options->compositors, ao2_bump(task_data->endpoint_state_compositor));
+
+	ao2_lock(task_data->endpoint_state_compositor);
+	ast_str_container_add(task_data->endpoint_state_compositor->aors, task_data->aor_options->name);
+	if (task_data->aor_options->available) {
+		task_data->endpoint_state_compositor->available++;
 	}
+	ao2_unlock(task_data->endpoint_state_compositor);
 
 	return 0;
 }
 
-/*!
- * \internal
- * \brief Scheduling context for sending QUALIFY request at specified intervals.
- */
-static struct ast_sched_context *sched;
+/*! \brief Task which adds removes an AOR from an endpoint state compositor */
+static int sip_options_endpoint_compositor_remove_task(void *obj)
+{
+	struct sip_options_endpoint_compositor_task_data *task_data = obj;
+	int i;
 
-/*!
- * \internal
- * \brief Container to hold all actively scheduled qualifies.
- */
-static struct ao2_container *sched_qualifies;
+	ast_debug(3, "Removing endpoint compositor '%s' from AOR '%s'\n", task_data->endpoint_state_compositor->name,
+		task_data->aor_options->name);
 
-/*!
- * \internal
- * \brief Structure to hold qualify contact scheduling information.
- */
-struct sched_data {
-	/*! The scheduling id */
-	int id;
-	/*! The the contact being checked */
-	struct ast_sip_contact *contact;
-};
+	for (i = 0; i < AST_VECTOR_SIZE(&task_data->aor_options->compositors); ++i) {
+		struct sip_options_endpoint_state_compositor *endpoint_state_compositor =
+			AST_VECTOR_GET(&task_data->aor_options->compositors, i);
 
-/*!
- * \internal
- * \brief Destroy the scheduled data and remove from scheduler.
- */
-static void sched_data_destructor(void *obj)
-{
-	struct sched_data *data = obj;
+		if (endpoint_state_compositor != task_data->endpoint_state_compositor) {
+			continue;
+		}
+
+		AST_VECTOR_REMOVE(&task_data->aor_options->compositors, i, 0);
+		ao2_ref(endpoint_state_compositor, -1);
+
+		break;
+	}
 
-	ao2_cleanup(data->contact);
+	return 0;
 }
-/*!
- * \internal
- * \brief Create the scheduling data object.
- */
-static struct sched_data *sched_data_create(struct ast_sip_contact *contact)
+
+/*! \brief Synchronize an endpoint with our local state */
+static int sip_options_synchronize_endpoint(void *obj, void *arg, int flags)
 {
-	struct sched_data *data;
+	struct ast_sip_endpoint *endpoint = obj;
+	struct ast_sip_aor *aor = arg;
+	char *aors;
+	char *aor_name;
+	struct sip_options_endpoint_compositor_task_data task_data = { NULL, };
 
-	data = ao2_t_alloc(sizeof(*data), sched_data_destructor, contact->uri);
-	if (!data) {
-		ast_log(LOG_ERROR, "Unable to create schedule qualify data for contact %s\n",
-			contact->uri);
-		return NULL;
+	if (ast_strlen_zero(endpoint->aors)) {
+		/* There are no AORs, so really... who the heck knows */
+		ast_debug(3, "Endpoint '%s' is not interested in any AORs so not creating endpoint state compositor\n",
+			ast_sorcery_object_get_id(endpoint));
+		return 0;
 	}
 
-	data->contact = contact;
-	ao2_ref(data->contact, +1);
+	ast_debug(3, "Synchronizing endpoint '%s' with AORs '%s'\n", ast_sorcery_object_get_id(endpoint),
+		endpoint->aors);
 
-	return data;
-}
+	aors = ast_strdupa(endpoint->aors);
+	while ((aor_name = ast_strip(strsep(&aors, ",")))) {
+		if (aor && strcasecmp(ast_sorcery_object_get_id(aor), aor_name)) {
+			ast_debug(3, "Filtered AOR '%s' on endpoint '%s' as we are looking for '%s'\n",
+				aor_name, ast_sorcery_object_get_id(endpoint), ast_sorcery_object_get_id(aor));
+			continue;
+		}
 
-/*!
- * \internal
- * \brief Send a qualify contact request within a threaded task.
- */
-static int qualify_contact_task(void *obj)
-{
-	struct ast_sip_contact *contact = obj;
-	int res;
+		task_data.aor_options = ao2_find(sip_options_aors, aor_name, OBJ_SEARCH_KEY);
+		if (!task_data.aor_options) {
+			/* They have referenced an invalid AOR. We don't know if they are online or offline. */
+			ast_debug(3, "Endpoint '%s' referenced invalid AOR '%s' so defaulting to initial offline state\n",
+				ast_sorcery_object_get_id(endpoint), aor_name);
+			ast_sip_persistent_endpoint_update_state(ast_sorcery_object_get_id(endpoint), AST_ENDPOINT_OFFLINE);
+			continue;
+		}
+
+		if (!task_data.endpoint_state_compositor) {
+			/* We create an endpoint state compositor only after we know for sure we need it */
+			task_data.endpoint_state_compositor = sip_options_endpoint_state_compositor_find_or_alloc(endpoint);
+			if (!task_data.endpoint_state_compositor) {
+				ast_log(LOG_WARNING, "Could not create endpoint state compositor for '%s', endpoint state will be incorrect\n",
+					ast_sorcery_object_get_id(endpoint));
+				ao2_ref(task_data.aor_options, -1);
+				ast_sip_persistent_endpoint_update_state(ast_sorcery_object_get_id(endpoint), AST_ENDPOINT_OFFLINE);
+				return 0;
+			}
+		}
+
+		/* We use a synchronous task so that we don't flood the system */
+		ast_sip_push_task_synchronous(task_data.aor_options->serializer, sip_options_endpoint_compositor_add_task, &task_data);
+
+		ao2_ref(task_data.aor_options, -1);
+
+		/* If we filtered on a specific AOR name then the endpoint can only reference it once so break early */
+		if (aor) {
+			break;
+		}
+	}
 
-	res = qualify_contact(NULL, contact);
-	ao2_ref(contact, -1);
-	return res;
+	/* If an endpoint state compositor is present determine the current state of the endpoint and update it */
+	if (task_data.endpoint_state_compositor) {
+		ao2_lock(task_data.endpoint_state_compositor);
+		ast_sip_persistent_endpoint_update_state(ast_sorcery_object_get_id(endpoint), task_data.endpoint_state_compositor->available ? AST_ENDPOINT_ONLINE : AST_ENDPOINT_OFFLINE);
+		ao2_unlock(task_data.endpoint_state_compositor);
+		ao2_ref(task_data.endpoint_state_compositor, -1);
+	}
+
+	return 0;
 }
 
-/*!
- * \internal
- * \brief Send a scheduled qualify contact request.
- */
-static int qualify_contact_sched(const void *obj)
+/*! \brief Callback which removes any unused AORs that remained after reloading */
+static int sip_options_unused_aor(void *obj, void *arg, int flags)
 {
-	struct sched_data *data = (struct sched_data *) obj;
+	struct sip_options_aor *aor_options = obj;
+	int i;
 
-	ao2_ref(data->contact, +1);
-	if (ast_sip_push_task(NULL, qualify_contact_task, data->contact)) {
-		ao2_ref(data->contact, -1);
-	}
+	ast_debug(3, "AOR '%s' is no longer configured, removing it\n", aor_options->name);
 
-	/*
-	 * Always reschedule rather than have a potential race cleaning
-	 * up the data object ref between self deletion and an external
-	 * deletion.
+	/* This AOR is no longer present so remove itself from the endpoint state compositor. If this
+	 * results in the endpoint state compositor no longer having any AORs feeding it then it'll go away
+	 * shortly after.
 	 */
-	return data->contact->qualify_frequency * 1000;
-}
+	for (i = 0; i < AST_VECTOR_SIZE(&aor_options->compositors); ++i) {
+		struct sip_options_endpoint_state_compositor *endpoint_state_compositor =
+			AST_VECTOR_GET(&aor_options->compositors, i);
 
-/*!
- * \internal
- * \brief Set up a scheduled qualify contact check.
- */
-static void schedule_qualify(struct ast_sip_contact *contact, int initial_interval)
-{
-	struct sched_data *data;
+		ao2_lock(endpoint_state_compositor);
 
-	data = sched_data_create(contact);
-	if (!data) {
-		return;
+		endpoint_state_compositor->aors = 0;
+		endpoint_state_compositor->available = 0;
+
+		ao2_unlock(endpoint_state_compositor);
+		ao2_ref(endpoint_state_compositor, -1);
 	}
 
-	ast_assert(contact->qualify_frequency != 0);
+	AST_SCHED_DEL_UNREF(sched, aor_options->sched_id, ao2_t_ref(aor_options, -1, "Delete scheduler entry ref"));
+	ao2_unlink(sip_options_aors, aor_options);
 
-	ao2_t_ref(data, +1, "Ref for qualify_contact_sched() scheduler entry");
-	data->id = ast_sched_add_variable(sched, initial_interval,
-		qualify_contact_sched, data, 1);
-	if (data->id < 0) {
-		ao2_t_ref(data, -1, "Cleanup failed scheduler add");
-		ast_log(LOG_ERROR, "Unable to schedule qualify for contact %s\n",
-			contact->uri);
-	} else if (!ao2_link(sched_qualifies, data)) {
-		AST_SCHED_DEL_UNREF(sched, data->id,
-			ao2_t_ref(data, -1, "Cleanup scheduler for failed ao2_link"));
-	}
-	ao2_t_ref(data, -1, "Done setting up scheduler entry");
+	return CMP_MATCH;
 }
 
-/*!
- * \internal
- * \brief Remove the contact from the scheduler.
- */
-static void unschedule_qualify(struct ast_sip_contact *contact)
+/*! \brief Callback function used to unlink and remove event state compositors that have no AORs feeding them */
+static int sip_options_unused_endpoint_state_compositor(void *obj, void *arg, int flags)
 {
-	struct sched_data *data;
+	struct sip_options_endpoint_state_compositor *endpoint_state_compositor = obj;
 
-	data = ao2_find(sched_qualifies, contact, OBJ_UNLINK | OBJ_SEARCH_KEY);
-	if (!data) {
-		return;
+	if (endpoint_state_compositor->aors) {
+		return 0;
 	}
 
-	AST_SCHED_DEL_UNREF(sched, data->id,
-		ao2_t_ref(data, -1, "Delete scheduler entry ref"));
-	ao2_t_ref(data, -1, "Done with ao2_find ref");
+	ast_sip_persistent_endpoint_update_state(endpoint_state_compositor->name, AST_ENDPOINT_OFFLINE);
+
+	return CMP_MATCH;
 }
 
-/*!
- * \internal
- * \brief Qualify the given contact and set up scheduling if configured.
- */
-static void qualify_and_schedule(struct ast_sip_contact *contact)
+/*! \brief Structure which contains information required to synchronize */
+struct sip_options_synchronize_task_data {
+	/*! \brief Whether this is a reload or not */
+	int reload;
+};
+
+/*! \brief Task which synchronizse our local container of AORs and endpoint state compositors with the current configuration */
+static int sip_options_synchronize_task(void *obj)
 {
-	unschedule_qualify(contact);
+	struct sip_options_synchronize_task_data *task_data = obj;
+	struct ao2_container *existing = NULL;
+	struct ao2_container *objects;
 
-	if (contact->qualify_frequency) {
-		ao2_ref(contact, +1);
-		if (ast_sip_push_task(NULL, qualify_contact_task, contact)) {
-			ao2_ref(contact, -1);
+	/* When reloading we keep track of the existing AORs so we can terminate old ones that are
+	 * no longer referenced or used.
+	 */
+	if (task_data->reload) {
+		existing = ao2_container_clone(sip_options_aors, 0);
+		if (!existing) {
+			return 0;
 		}
+	}
 
-		schedule_qualify(contact, contact->qualify_frequency * 1000);
-	} else {
-		update_contact_status(contact, UNKNOWN, 0);
+	objects = ast_sorcery_retrieve_by_fields(ast_sip_get_sorcery(), "aor",
+		AST_RETRIEVE_FLAG_MULTIPLE | AST_RETRIEVE_FLAG_ALL, NULL);
+	if (objects) {
+		/* Go through the returned AORs and synchronize with our local state */
+		ao2_callback(objects, OBJ_NODATA, sip_options_synchronize_aor, existing);
+		ao2_ref(objects, -1);
 	}
-}
 
-/*!
- * \internal
- * \brief A new contact has been created make sure it is available.
- */
-static void contact_created(const void *obj)
-{
-	qualify_and_schedule((struct ast_sip_contact *) obj);
+	/* Any AORs remaining in existing are no longer referenced by the current container of
+	 * AORs we retrieved, so remove them.
+	 */
+	if (existing) {
+		ao2_callback(existing, OBJ_NODATA | OBJ_MULTIPLE | OBJ_UNLINK, sip_options_unused_aor, NULL);
+		ao2_ref(existing, -1);
+	}
+
+	objects = ast_sorcery_retrieve_by_fields(ast_sip_get_sorcery(), "endpoint",
+		AST_RETRIEVE_FLAG_MULTIPLE | AST_RETRIEVE_FLAG_ALL, NULL);
+	if (objects) {
+		/* Go through the provided endpoints and update AORs */
+		ao2_callback(objects, OBJ_NODATA, sip_options_synchronize_endpoint, NULL);
+		ao2_ref(objects, -1);
+	}
+
+	/* All endpoint state compositors that don't have any AORs feeding them information
+	 * can be removed. If they end up getting needed later they'll just be recreated.
+	 */
+	ao2_callback(sip_options_endpoint_state_compositors, OBJ_NODATA | OBJ_MULTIPLE | OBJ_UNLINK,
+		sip_options_unused_endpoint_state_compositor, NULL);
+
+	return 0;
 }
 
-/*!
- * \internal
- * \brief A contact has been updated.
- */
-static void contact_updated(const void *obj)
+/*! \brief Synchronize our local container of AORs and endpoint state compositors with the current configuration */
+static void sip_options_synchronize(int reload)
 {
-	update_contact_status(obj, AVAILABLE, 1);
+	struct sip_options_synchronize_task_data task_data = { .reload = reload, };
+
+	ast_sip_push_task_synchronous(management_serializer, sip_options_synchronize_task, &task_data);
 }
 
-/*!
- * \internal
- * \brief A contact has been deleted remove status tracking.
- */
-static void contact_deleted(const void *obj)
+/*! \brief Task which deletes an endpoint from the known universe in the management serializer */
+static int sip_options_endpoint_observer_deleted_task(void *obj)
 {
-	struct ast_sip_contact *contact = (struct ast_sip_contact *) obj;
-	struct ast_sip_contact_status *status;
-
-	unschedule_qualify(contact);
+	struct ast_sip_endpoint *endpoint = obj;
+	struct sip_options_endpoint_compositor_task_data task_data = { NULL, };
+	struct ao2_iterator it_aors;
+	char *aor;
 
-	status = ast_sorcery_retrieve_by_id(ast_sip_get_sorcery(), CONTACT_STATUS,
-		ast_sorcery_object_get_id(contact));
-	if (!status) {
-		return;
+	task_data.endpoint_state_compositor = ao2_find(sip_options_endpoint_state_compositors, ast_sorcery_object_get_id(endpoint), OBJ_SEARCH_KEY | OBJ_UNLINK);
+	if (!task_data.endpoint_state_compositor) {
+		return 0;
 	}
 
-	if (ast_sorcery_delete(ast_sip_get_sorcery(), status)) {
-		ast_log(LOG_ERROR, "Unable to delete ast_sip_contact_status for contact %s\n",
-			contact->uri);
-	}
-	ao2_ref(status, -1);
-}
+	ast_debug(3, "Endpoint '%s' has been deleted, removing endpoint state compositor from AORs\n",
+		ast_sorcery_object_get_id(endpoint));
 
-static const struct ast_sorcery_observer contact_observer = {
-	.created = contact_created,
-	.updated = contact_updated,
-	.deleted = contact_deleted,
-};
+	it_aors = ao2_iterator_init(task_data.endpoint_state_compositor->aors, 0);
+	for (; (aor = ao2_iterator_next(&it_aors)); ao2_ref(aor, -1)) {
+		task_data.aor_options = ao2_find(sip_options_aors, aor, OBJ_SEARCH_KEY);
+		if (!task_data.aor_options) {
+			continue;
+		}
 
-static pj_bool_t options_start(void)
-{
-	sched = ast_sched_context_create();
-	if (!sched) {
-		return -1;
-	}
-	if (ast_sched_start_thread(sched)) {
-		ast_sched_context_destroy(sched);
-		sched = NULL;
-		return -1;
+		ast_debug(3, "Removing endpoint state compositor '%s' from AOR '%s'\n",
+			ast_sorcery_object_get_id(endpoint), aor);
+		ast_sip_push_task_synchronous(task_data.aor_options->serializer, sip_options_endpoint_compositor_remove_task, &task_data);
+		ao2_ref(task_data.aor_options, -1);
 	}
+	ao2_iterator_destroy(&it_aors);
 
-	if (ast_sorcery_observer_add(ast_sip_get_sorcery(), "contact", &contact_observer)) {
-		ast_log(LOG_WARNING, "Unable to add contact observer\n");
-		ast_sched_context_destroy(sched);
-		sched = NULL;
-		return -1;
-	}
+	ao2_ref(task_data.endpoint_state_compositor, -1);
 
-	return PJ_SUCCESS;
+	return 0;
 }
 
-static int sched_qualifies_empty(void *obj, void *arg, int flags)
+/*! \brief Observer callback invoked on endpoint deletion */
+static void endpoint_observer_deleted(const void *obj)
 {
-	ao2_t_ref(obj, -1, "Release ref held by destroyed scheduler context.");
-	return CMP_MATCH;
+	ast_sip_push_task_synchronous(management_serializer, sip_options_endpoint_observer_deleted_task, (void *)obj);
 }
 
-static pj_bool_t options_stop(void)
-{
-	ast_sorcery_observer_remove(ast_sip_get_sorcery(), "contact", &contact_observer);
 
-	if (sched) {
-		ast_sched_context_destroy(sched);
-		sched = NULL;
-	}
+/*! \brief Task which synchronizes the endpoint in the management serializer */
+static int sip_options_endpoint_observer_modified_task(void *obj)
+{
+	/* Instead of trying to reconcile the existing endpoint state compositor we simply delete the old one
+	 * and create a new one. Since this is only for a single endpoint and state will still be correct afterwards
+	 * it is easiest and makes the most sense.
+	 */
+	sip_options_endpoint_observer_deleted_task(obj);
+	sip_options_synchronize_endpoint(obj, NULL, 0);
 
-	/* Empty the container of scheduling data refs. */
-	ao2_callback(sched_qualifies, OBJ_UNLINK | OBJ_NODATA | OBJ_MULTIPLE,
-		sched_qualifies_empty, NULL);
+	return 0;
+}
 
-	return PJ_SUCCESS;
+/*! \brief Observer callback invoked on endpoint creation or modification */
+static void endpoint_observer_modified(const void *obj)
+{
+	ast_sip_push_task_synchronous(management_serializer, sip_options_endpoint_observer_modified_task, (void *)obj);
 }
 
-static pj_status_t send_options_response(pjsip_rx_data *rdata, int code)
+/*! \brief Observer callbacks for endpoints */
+static const struct ast_sorcery_observer endpoint_observer_callbacks = {
+	.created = endpoint_observer_modified,
+	.updated = endpoint_observer_modified,
+	.deleted = endpoint_observer_deleted,
+};
+
+/*! \brief Task to synchronize an AOR with our local state */
+static int sip_options_update_aor_task(void *obj)
 {
-	pjsip_endpoint *endpt = ast_sip_get_pjsip_endpoint();
-	pjsip_dialog *dlg = pjsip_rdata_get_dlg(rdata);
-	pjsip_transaction *trans = pjsip_rdata_get_tsx(rdata);
-	pjsip_tx_data *tdata;
-	const pjsip_hdr *hdr;
-	pj_status_t status;
+	struct sip_options_synchronize_aor_task_data *task_data = obj;
+	int available = task_data->aor_options->available;
 
-	/* Make the response object */
-	status = ast_sip_create_response(rdata, code, NULL, &tdata);
-	if (status != PJ_SUCCESS) {
-		ast_log(LOG_ERROR, "Unable to create response (%d)\n", status);
-		return status;
-	}
+	ast_debug(3, "Individually updating AOR '%s' with current state of configuration and world\n",
+		task_data->aor_options->name);
 
-	/* Add appropriate headers */
-	if ((hdr = pjsip_endpt_get_capability(endpt, PJSIP_H_ACCEPT, NULL))) {
-		pjsip_msg_add_hdr(tdata->msg, (pjsip_hdr*)pjsip_hdr_clone(tdata->pool, hdr));
-	}
-	if ((hdr = pjsip_endpt_get_capability(endpt, PJSIP_H_ALLOW, NULL))) {
-		pjsip_msg_add_hdr(tdata->msg, (pjsip_hdr*)pjsip_hdr_clone(tdata->pool, hdr));
+	sip_options_apply_aor_configuration(task_data->aor_options, task_data->aor, task_data->added);
+
+	if (!available && task_data->aor_options->available) {
+		ast_debug(3, "After modifying AOR '%s' it has now become available\n",
+			task_data->aor_options->name);
+		sip_options_notify_endpoint_state_compositors(task_data->aor_options, AVAILABLE);
+	} else if (available && !task_data->aor_options->available) {
+		ast_debug(3, "After modifying AOR '%s' it has become unavailable\n",
+			task_data->aor_options->name);
+		sip_options_notify_endpoint_state_compositors(task_data->aor_options, UNAVAILABLE);
 	}
-	if ((hdr = pjsip_endpt_get_capability(endpt, PJSIP_H_SUPPORTED, NULL))) {
-		pjsip_msg_add_hdr(tdata->msg, (pjsip_hdr*)pjsip_hdr_clone(tdata->pool, hdr));
+
+	return 0;
+}
+
+/*! \brief Task which synchronizes the AOR in the management serializer */
+static int sip_options_aor_observer_modified_task(void *obj)
+{
+	struct ast_sip_aor *aor = obj;
+	struct sip_options_aor *aor_options;
+	int added = 0;
+
+	aor_options = ao2_find(sip_options_aors, ast_sorcery_object_get_id(aor), OBJ_SEARCH_KEY);
+	if (!aor_options) {
+		aor_options = sip_options_aor_alloc(aor);
+		if (!aor_options) {
+			return 0;
+		}
+		added = 1;
 	}
 
-	/*
-	 * XXX TODO: pjsip doesn't care a lot about either of these headers -
-	 * while it provides specific methods to create them, they are defined
-	 * to be the standard string header creation. We never did add them
-	 * in chan_sip, although RFC 3261 says they SHOULD. Hard coded here.
+	/* If this is a newly added AOR we need to establish any endpoint state compositors
+	 * that may reference only the AOR. If these need to be updated later then they'll be done
+	 * by modifying the endpoint or issuing a reload.
 	 */
-	ast_sip_add_header(tdata, "Accept-Encoding", DEFAULT_ENCODING);
-	ast_sip_add_header(tdata, "Accept-Language", DEFAULT_LANGUAGE);
+	if (added) {
+		struct ao2_container *endpoints;
 
-	if (dlg && trans) {
-		status = pjsip_dlg_send_response(dlg, trans, tdata);
+		sip_options_apply_aor_configuration(aor_options, aor, added);
+		ao2_link(sip_options_aors, aor_options);
+
+		/* Using LIKE doesn't seem to work very well with non-realtime so we pull everything
+		 * right now and do a filter on our side.
+		 */
+		endpoints = ast_sorcery_retrieve_by_fields(ast_sip_get_sorcery(),
+			"endpoint", AST_RETRIEVE_FLAG_MULTIPLE | AST_RETRIEVE_FLAG_ALL, NULL);
+		if (endpoints) {
+			ao2_callback(endpoints, OBJ_NODATA, sip_options_synchronize_endpoint, aor);
+			ao2_ref(endpoints, -1);
+		}
 	} else {
-		struct ast_sip_endpoint *endpoint;
+		struct sip_options_synchronize_aor_task_data task_data = { .aor_options = aor_options, .aor = aor, };
 
-		endpoint = ast_pjsip_rdata_get_endpoint(rdata);
-		status = ast_sip_send_stateful_response(rdata, tdata, endpoint);
-		ao2_cleanup(endpoint);
+		/* If this AOR was modified we have to do our work in its serializer instead of this
+		 * thread to ensure that things aren't modified by multiple threads.
+		 */
+		ast_sip_push_task_synchronous(aor_options->serializer, sip_options_update_aor_task, &task_data);
 	}
 
-	if (status != PJ_SUCCESS) {
-		ast_log(LOG_ERROR, "Unable to send response (%d)\n", status);
-	}
+	ao2_ref(aor_options, -1);
 
-	return status;
+	return 0;
 }
 
-static pj_bool_t options_on_rx_request(pjsip_rx_data *rdata)
+/*! \brief Observer callback invoked on AOR creation or modification */
+static void aor_observer_modified(const void *obj)
 {
-	RAII_VAR(struct ast_sip_endpoint *, endpoint, NULL, ao2_cleanup);
-	pjsip_uri *ruri;
-	pjsip_sip_uri *sip_ruri;
-	char exten[AST_MAX_EXTENSION];
-
-	if (pjsip_method_cmp(&rdata->msg_info.msg->line.req.method, &pjsip_options_method)) {
-		return PJ_FALSE;
-	}
+	ast_sip_push_task_synchronous(management_serializer, sip_options_aor_observer_modified_task, (void *)obj);
+}
 
-	if (!(endpoint = ast_pjsip_rdata_get_endpoint(rdata))) {
-		return PJ_FALSE;
-	}
+/*! \brief Task which deletes an AOR from the known universe in the management serializer */
+static int sip_options_aor_observer_deleted_task(void *obj)
+{
+	struct ast_sip_aor *aor = obj;
+	struct sip_options_aor *aor_options;
+	int i;
 
-	ruri = rdata->msg_info.msg->line.req.uri;
-	if (!PJSIP_URI_SCHEME_IS_SIP(ruri) && !PJSIP_URI_SCHEME_IS_SIPS(ruri)) {
-		send_options_response(rdata, 416);
-		return PJ_TRUE;
+	aor_options = ao2_find(sip_options_aors, ast_sorcery_object_get_id(aor), OBJ_SEARCH_KEY | OBJ_UNLINK);
+	if (!aor_options) {
+		return 0;
 	}
 
-	sip_ruri = pjsip_uri_get_uri(ruri);
-	ast_copy_pj_str(exten, &sip_ruri->user, sizeof(exten));
+	ast_debug(3, "AOR '%s' has been deleted, removing it\n", aor_options->name);
 
-	/*
-	 * We may want to match in the dialplan without any user
-	 * options getting in the way.
+	/* This AOR is no longer present so remove itself from the endpoint state compositor. If this
+	 * results in the endpoint state compositor no longer having any AORs feeding it then it'll go away
+	 * shortly after.
 	 */
-	AST_SIP_USER_OPTIONS_TRUNCATE_CHECK(exten);
+	for (i = 0; i < AST_VECTOR_SIZE(&aor_options->compositors); ++i) {
+		struct sip_options_endpoint_state_compositor *endpoint_state_compositor =
+			AST_VECTOR_GET(&aor_options->compositors, i);
 
-	if (ast_shutting_down()) {
-		/*
-		 * Not taking any new calls at this time.
-		 * Likely a server availability OPTIONS poll.
-		 */
-		send_options_response(rdata, 503);
-	} else if (!ast_strlen_zero(exten)
-		&& !ast_exists_extension(NULL, endpoint->context, exten, 1, NULL)) {
-		send_options_response(rdata, 404);
-	} else {
-		send_options_response(rdata, 200);
-	}
-	return PJ_TRUE;
-}
+		ao2_lock(endpoint_state_compositor);
 
-static pjsip_module options_module = {
-	.name = {"Options Module", 14},
-	.id = -1,
-	.priority = PJSIP_MOD_PRIORITY_APPLICATION,
-	.start = options_start,
-	.stop = options_stop,
-	.on_rx_request = options_on_rx_request,
-};
+		if (aor_options->available) {
+			endpoint_state_compositor->available--;
+		}
+		ast_str_container_remove(endpoint_state_compositor->aors, aor_options->name);
+
+		ao2_unlock(endpoint_state_compositor);
+
+		/* If there are no other AORs feeding this endpoint state compositor then away it goes. */
+		if (!ao2_container_count(endpoint_state_compositor->aors)) {
+			ast_debug(3, "Endpoint state compositor '%s' is being removed as the last AOR '%s' referencing it is being removed\n",
+				endpoint_state_compositor->name, aor_options->name);
+			ast_sip_persistent_endpoint_update_state(endpoint_state_compositor->name, AST_ENDPOINT_OFFLINE);
+			ao2_unlink(sip_options_endpoint_state_compositors, endpoint_state_compositor);
+		} else if (!endpoint_state_compositor->available) {
+			ast_debug(3, "Endpoint state compositor '%s' has become unavailable due to AOR being deleted, updating endpoint state\n",
+				endpoint_state_compositor->name);
+			ast_sip_persistent_endpoint_update_state(endpoint_state_compositor->name, AST_ENDPOINT_OFFLINE);
+		}
 
-/*!
- * \internal
- * \brief Send qualify request to the given contact.
- */
-static int cli_on_contact(void *obj, void *arg, void *data, int flags)
-{
-	struct ast_sip_contact *contact = obj;
-	struct ast_sip_endpoint *endpoint = data;
-	int *cli_fd = arg;
+		ao2_ref(endpoint_state_compositor, -1);
+	}
+
+	AST_SCHED_DEL_UNREF(sched, aor_options->sched_id, ao2_t_ref(aor_options, -1, "Delete scheduler entry ref"));
+	ao2_ref(aor_options, -1);
 
-	ast_cli(*cli_fd, " contact %s\n", contact->uri);
-	qualify_contact(endpoint, contact);
 	return 0;
 }
 
-/*!
- * \brief Data pushed to threadpool to qualify endpoints from the CLI
- */
-struct qualify_data {
-	/*! Endpoint that is being qualified */
-	struct ast_sip_endpoint *endpoint;
-	/*! CLI File descriptor for printing messages */
-	int cli_fd;
+/*! \brief Observer callback invoked on AOR deletion */
+static void aor_observer_deleted(const void *obj)
+{
+	ast_sip_push_task_synchronous(management_serializer, sip_options_aor_observer_deleted_task, (void *)obj);
+}
+
+/*! \brief Observer callbacks for AORs */
+static const struct ast_sorcery_observer aor_observer_callbacks = {
+	.created = aor_observer_modified,
+	.updated = aor_observer_modified,
+	.deleted = aor_observer_deleted,
 };
 
-static struct qualify_data *qualify_data_alloc(struct ast_sip_endpoint *endpoint, int cli_fd)
-{
-	struct qualify_data *qual_data;
+/*! \brief Task details for adding an AOR to an endpoint state compositor */
+struct sip_options_contact_observer_task_data {
+	/*! \brief The AOR options that the contact is referring to */
+	struct sip_options_aor *aor_options;
+	/*! \brief The contact itself */
+	struct ast_sip_contact *contact;
+};
 
-	qual_data = ast_malloc(sizeof(*qual_data));
-	if (!qual_data) {
-		return NULL;
+/*! \brief Task which adds a dynamic contact to an AOR */
+static int sip_options_contact_add_task(void *obj)
+{
+	struct sip_options_contact_observer_task_data *task_data = obj;
+
+	ao2_link(task_data->aor_options->dynamic_contacts, task_data->contact);
+
+	if (task_data->aor_options->qualify_frequency) {
+		/* If this is the first contact we need to schedule up qualification */
+		if ((ao2_container_count(task_data->aor_options->dynamic_contacts) + ao2_container_count(task_data->aor_options->permanent_contacts)) == 1) {
+			ast_debug(3, "Starting scheduled callback on AOR '%s' for qualifying as there is now a contact on it\n",
+				task_data->aor_options->name);
+			/* We immediately schedule the initial qualify so that we get reachable/unreachable as soon as possible.
+			 * Realistically since they pretty much just registered they should be reachable.
+			 */
+			task_data->aor_options->sched_id = ast_sched_add_variable(sched, 1, sip_options_qualify_aor,
+				ao2_bump(task_data->aor_options), 1);
+			if (task_data->aor_options->sched_id < 0) {
+				ao2_t_ref(task_data->aor_options, -1, "Cleanup failed scheduler add");
+				ast_log(LOG_ERROR, "Unable to schedule qualify for contacts of AOR '%s'\n", task_data->aor_options->name);
+			}
+		}
+	} else {
+		/* If this was the first contact added to a non-qualified AOR then
+		 * it should become available.
+		 */
+		task_data->aor_options->available++;
+		if (task_data->aor_options->available == 1) {
+			ast_debug(3, "An unqualified contact has been added to AOR '%s' so it is now available\n",
+				task_data->aor_options->name);
+			sip_options_notify_endpoint_state_compositors(task_data->aor_options, AVAILABLE);
+		}
 	}
 
-	qual_data->endpoint = ao2_bump(endpoint);
-	qual_data->cli_fd = cli_fd;
-	return qual_data;
+	return 0;
 }
 
-static void qualify_data_destroy(struct qualify_data *qual_data)
+/*! \brief Observer callback invoked on contact creation */
+static void contact_observer_created(const void *obj)
 {
-	ao2_cleanup(qual_data->endpoint);
-	ast_free(qual_data);
+	struct sip_options_contact_observer_task_data task_data;
+
+	task_data.contact = (struct ast_sip_contact *)obj;
+	task_data.aor_options = ao2_find(sip_options_aors, task_data.contact->aor, OBJ_SEARCH_KEY);
+	if (!task_data.aor_options) {
+		struct ast_sip_aor *aor;
+
+		/* The only reason this would occur is if the AOR was sourced after the last reload
+		 * happened. To handle this we pull the AOR and treat it as if we received notification
+		 * that it had been created. This will cause it to get created for qualify and any
+		 * endpoint state compositors to also get created.
+		 */
+		aor = ast_sorcery_retrieve_by_id(ast_sip_get_sorcery(), "aor", task_data.contact->aor);
+		if (aor) {
+			aor_observer_modified(aor);
+			ao2_ref(aor, -1);
+		}
+		return;
+	}
+
+	ast_sip_push_task_synchronous(task_data.aor_options->serializer, sip_options_contact_add_task, &task_data);
+	ao2_ref(task_data.aor_options, -1);
 }
 
-/*!
- * \internal
- * \brief For an endpoint iterate over and qualify all aors/contacts
- */
-static int cli_qualify_contacts(void *data)
+/*! \brief Task which deletes a dynamic contact from an AOR */
+static int sip_options_contact_delete_task(void *obj)
 {
-	char *aors;
-	char *aor_name;
-	RAII_VAR(struct qualify_data *, qual_data, data, qualify_data_destroy);
-	struct ast_sip_endpoint *endpoint = qual_data->endpoint;
-	int cli_fd = qual_data->cli_fd;
-	const char *endpoint_name = ast_sorcery_object_get_id(endpoint);
+	struct sip_options_contact_observer_task_data *task_data = obj;
 
-	if (ast_strlen_zero(endpoint->aors)) {
-		ast_cli(cli_fd, "Endpoint %s has no AoR's configured\n",
-			endpoint_name);
-		return 0;
-	}
+	ao2_find(task_data->aor_options->dynamic_contacts, task_data->contact, OBJ_NODATA | OBJ_UNLINK | OBJ_SEARCH_OBJECT);
 
-	aors = ast_strdupa(endpoint->aors);
-	while ((aor_name = ast_strip(strsep(&aors, ",")))) {
-		struct ast_sip_aor *aor;
-		struct ao2_container *contacts;
+	sip_options_remove_contact_status(task_data->aor_options, task_data->contact);
 
-		aor = ast_sip_location_retrieve_aor(aor_name);
-		if (!aor) {
-			continue;
+	if (task_data->aor_options->qualify_frequency) {
+		/* If this is the last contact then we need to stop the scheduled callback */
+		if ((ao2_container_count(task_data->aor_options->dynamic_contacts) + ao2_container_count(task_data->aor_options->permanent_contacts)) == 0) {
+			ast_debug(3, "Terminating scheduled callback on AOR '%s' as there are no contacts to qualify\n",
+				task_data->aor_options->name);
+			AST_SCHED_DEL_UNREF(sched, task_data->aor_options->sched_id, ao2_t_ref(task_data->aor_options, -1, "Delete scheduler entry ref"));
 		}
-
-		contacts = ast_sip_location_retrieve_aor_contacts(aor);
-		if (contacts) {
-			ast_cli(cli_fd, "Sending qualify to endpoint %s\n", endpoint_name);
-			ao2_callback_data(contacts, OBJ_NODATA, cli_on_contact, &cli_fd, endpoint);
-			ao2_ref(contacts, -1);
+	} else {
+		task_data->aor_options->available--;
+		if (!task_data->aor_options->available) {
+			ast_debug(3, "An unqualified contact has been removed from AOR '%s' leaving no remaining contacts\n",
+				task_data->aor_options->name);
+			sip_options_notify_endpoint_state_compositors(task_data->aor_options, UNAVAILABLE);
 		}
-
-		ao2_ref(aor, -1);
 	}
+
 	return 0;
 }
 
+/*! \brief Observer callback invoked on contact deletion */
+static void contact_observer_deleted(const void *obj)
+{
+	struct sip_options_contact_observer_task_data task_data;
+
+	task_data.contact = (struct ast_sip_contact *)obj;
+	task_data.aor_options = ao2_find(sip_options_aors, task_data.contact->aor, OBJ_SEARCH_KEY);
+	if (!task_data.aor_options) {
+		/* For contacts that are deleted we don't really care if there is no AOR locally */
+		return;
+	}
+
+	ast_sip_push_task_synchronous(task_data.aor_options->serializer, sip_options_contact_delete_task, &task_data);
+	ao2_ref(task_data.aor_options, -1);
+}
+
+/*! \brief Observer callbacks for contacts */
+static const struct ast_sorcery_observer contact_observer_callbacks = {
+	.created = contact_observer_created,
+	.deleted = contact_observer_deleted,
+};
+
 static char *cli_qualify(struct ast_cli_entry *e, int cmd, struct ast_cli_args *a)
 {
 	RAII_VAR(struct ast_sip_endpoint *, endpoint, NULL, ao2_cleanup);
 	const char *endpoint_name;
-	struct qualify_data *qual_data;
+	char *aors;
+	char *aor_name;
 
 	switch (cmd) {
 	case CLI_INIT:
